//    (     - ,    8  + 2 
// Proteus; icq:133575351; lawnmower-man@mail.ru

#include<stdio.h>

typedef unsigned char BYTE;

class Encoder{
struct item_st{union{int count; int bit;};int p1;int p2;int p;}tree[512];
int file_size;	//!<  
int tree_root;	//!<  
BYTE byte,byte_shift;
FILE *input,*output;
//       
//          
//    
BYTE write_buff[8]; int write_count;	
	void WriteBit(int bit);			//!<    
	int  MakeTree();				//!<  
	void SetBits(int root,int bit); //!<    
	void WriteAll();				//!<    
	void WriteTree(int);			//!<   
	void DumpByte(FILE*,int);
	void Dump();					//!<   
	void PackByte(int);
	void Compress();
public:
	void Work(char*,char*);
};

//!      ,   - (    )
//!    512*512        
int Encoder::MakeTree()
{
	int min1,min2,n,n1,n2,n3;
	printf("[make tree]\n");
	n3=256;
	for(;;) {
		min1=min2=file_size+1;
		for(n=0; n<n3; n++) if(tree[n].count && tree[n].count<min1) min1=tree[n].count,n1=n;
		if(min1>file_size) return -1;
		tree[n1].count=0;
		for(n=0; n<n3; n++) if(tree[n].count && tree[n].count<min2) min2=tree[n].count,n2=n;
		if(min2>file_size) return n1;
		tree[n2].count=0;
		tree[n3].count=min1+min2;
		tree[n1].p=tree[n2].p=n3;
		tree[n3].p1=n1;
		tree[n3].p2=n2;
		tree[n3].p=-1;
		n3++;
	}
}


//!   
//! :  1  512  (1 - 64 )
//! +   (    )
//! :  1  256 
void Encoder::WriteTree(int root)
{
	if(root<256) {
		write_buff[write_count++]=root;
		WriteBit(0); 
	}else{
		WriteBit(1);
		WriteTree(tree[root].p1);
		WriteTree(tree[root].p2);
	}
}

//!    
void Encoder::SetBits(int root,int bit)
{
	if(root<0) return;
	tree[root].bit=bit;
	SetBits(tree[root].p1,0);
	SetBits(tree[root].p2,1);
}


void Encoder::WriteAll()
{
	printf("[write tree]\n");
	WriteTree(tree_root);
}

void Encoder::WriteBit(int b)
{
	if(b) byte|=byte_shift;
	byte_shift<<=1;
	if(byte_shift) return;
	fputc(byte,output);
	if(write_count) fwrite(write_buff,1,write_count,output),write_count=0;
	write_count=0;
	byte_shift=1; byte=0;
}


void Encoder::Dump()
{
	int n;
	FILE *file=fopen("dump.log","wt");
	for(n=0; n<256; n++) {
		if(tree[n].p<0) continue;
		fprintf(file,"%x:",n);
		DumpByte(file,n);
		fputc('\n',file);
	}
	fclose(file);
}


void Encoder::DumpByte(FILE *file,int root)
{
	if(root<0 || root==tree_root) return;
	DumpByte(file,tree[root].p);
	fputc('0'+tree[root].bit,file);
}

void Encoder::Compress()
{
	int n,m,s,progress=-1;
	printf("[pack]\n");
	s=file_size/100; if(!s) s=1;
	for(n=0; n<file_size; n++) {
		m=n/s; if(m!=progress) progress=m,printf("%d%%\r",progress);
		PackByte((BYTE)fgetc(input));
	}
	printf("[done]\n");
}

void Encoder::PackByte(int root)
{
	if(tree[root].p<0) return;
	PackByte(tree[root].p);
	WriteBit(tree[root].bit);
}


void Encoder::Work(char *in_name,char *out_name)
{
	int n; byte=0; byte_shift=1; write_count=0;
	input=fopen(in_name,"rb"); if(!input) {printf("in file not found\n");return;}
	fseek(input,0,SEEK_END);
	file_size=ftell(input);
	if(!file_size) {printf("input file is empty\n");return;}
	output=fopen(out_name,"wb"); if(!output) {printf("out file io error\n");return;}
	fseek(input,0,SEEK_SET); fwrite(&file_size,1,sizeof(file_size),output);
	for(n=0; n<512; n++) tree[n].count=0,tree[n].p=tree[n].p1=tree[n].p2=-1;
	printf("[calc symbols]\n");
	for(n=0; n<file_size; n++) tree[(BYTE)getc(input)].count++;
	tree_root=MakeTree();	//  
	SetBits(tree_root,-1);	//  
	WriteAll();				//    
	Dump();					//    
	rewind(input);
	Compress();				// 
	if(byte_shift!=1) fputc(byte,output);	//   
	fclose(input);
	fclose(output);
}



void main(int c,char **l)
{
	Encoder encoder;
	if(c!=3) {
		printf("Usage: %s <in_file> <out_file>\n",l[0]);
	} else encoder.Work(l[1],l[2]);
}



